local _, class = UnitClass("player")
if class == "HUNTER" then

local color = {
["DEATHKNIGHT"]={0.77, 0.12, 0.23},	["DEMONHUNTER"]={0.64, 0.19, 0.79},	["DRUID"]={1.00, 0.49, 0.04},
["HUNTER"]={0.67, 0.83, 0.45},		["MAGE"]={0.41, 0.80, 0.94},		["MONK"]={0.33, 0.54, 0.52},
["PALADIN"]={0.96, 0.55, 0.73},		["PRIEST"]={1.00, 1.00, 1.00},		["ROGUE"]={1.00, 0.96, 0.41},
["SHAMAN"]={0.0	, 0.44, 0.87},		["WARLOCK"]={0.58, 0.51, 0.79},		["WARRIOR"]={0.78, 0.61, 0.43},
}

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_TARGET")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Player = CreateFrame("Frame", nil, PlayerFrame)
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Hunter\\1")
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(64,64)
	Player.Textura:SetBlendMode("ADD")
	
	Player.Text = Player:CreateFontString(nil, "BORDER")
	Player.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Hunter.ttf", 11)
	Player.Text:SetPoint("CENTER", Player.Textura)
	Player.Text:SetTextColor(0.67,0.83,0.45)
	Player.Text:SetShadowColor(0,0,0)
	Player.Text:SetShadowOffset(1, -1)
	
	Player.SubTextura = Pulso:CreateTexture(nil,"BACKGROUND")
	Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Hunter\\Scalar")
	Player.SubTextura:SetPoint("CENTER", Player.Textura)
	Player.SubTextura:SetSize(128,128)
	Player.SubTextura:SetAlpha(0)
	
local Alvo = CreateFrame("Frame", nil, TargetFrame)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Hunter\\1")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(64,64)
	Alvo.Textura:SetBlendMode("ADD")
	Alvo.Textura:SetTexCoord(1,0,0,1)
	
	Alvo.Text = Alvo:CreateFontString(nil, "BORDER")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Hunter.ttf", 11)
	Alvo.Text:SetPoint("CENTER", Alvo.Textura)
	Alvo.Text:SetTextColor(0,0,0)
	Alvo.Text:SetShadowColor(0,0,0)
	Alvo.Text:SetShadowOffset(1, -1)
	
	Alvo.SubTextura = Pulso:CreateTexture(nil,"BACKGROUND")
	Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Hunter\\Scalar")
	Alvo.SubTextura:SetPoint("CENTER", Alvo.Textura)
	Alvo.SubTextura:SetSize(128,128)
	Alvo.SubTextura:SetAlpha(0)

--// Animations

	Player.AgLoop = Player.Textura:CreateAnimationGroup()
	Player.AgLoop:SetLooping("REPEAT")
	Player.Loop = Player.AgLoop:CreateAnimation("Rotation")
	Player.Loop:SetDuration(3)
	Player.Loop:SetDegrees(-480)	

	Alvo.AgLoop = Alvo.Textura:CreateAnimationGroup()
	Alvo.AgLoop:SetLooping("REPEAT")
	Alvo.Loop = Alvo.AgLoop:CreateAnimation("Rotation")
	Alvo.Loop:SetDuration(3)
	Alvo.Loop:SetDegrees(480)
	
	Pulso.AgScale = Pulso:CreateAnimationGroup()
	Pulso.Scale = Pulso.AgScale:CreateAnimation("Scale")
	Pulso.Scale:SetFromScale(.5,.5)
	Pulso.Scale:SetDuration(.5)
	Pulso.Scale:SetOrder(1)	
	Pulso.Scale2 = Pulso.AgScale:CreateAnimation("Scale")
	Pulso.Scale2:SetToScale(.5,.5)
	Pulso.Scale2:SetDuration(.5)
	Pulso.Scale2:SetOrder(2)


local function OnFinished(self)
	self:Play()
end Pulso.AgScale:SetScript("OnFinished", OnFinished)


local function OnEvent(self, event)

	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Player.Text:SetFormattedText("%.0f", hp)
	
	if UnitIsDeadOrGhost("player") then
		Player.AgLoop:Stop()
		Player.Text:SetAlpha(.5)
	else
		Player.AgLoop:Play()
		Player.Text:SetAlpha(1)
	end
	
	if UnitExists("target") then		
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		local _, class = UnitClass("target")

		if UnitIsDeadOrGhost("target") then
			Alvo.AgLoop:Stop()
			Alvo.Text:SetAlpha(.5)
		else
			Alvo.AgLoop:Play()
			Alvo.Text:SetAlpha(1)
		end
		
		Alvo:Show()
		Alvo.SubTextura:Show()

		Alvo.Text:SetFormattedText("%.0f", hp)
		Alvo.Text:SetTextColor(unpack(color[class]))
	else
		Alvo:Hide()
		Alvo.SubTextura:Hide()
	end

	if event == "PLAYER_REGEN_DISABLED" then
		Player.Textura:SetVertexColor(1,0,0)
		Alvo.Textura:SetVertexColor(1,0,0)
		Player.Loop:SetDuration(1)
		Alvo.Loop:SetDuration(1)
		Player.SubTextura:SetAlpha(1)
		Alvo.SubTextura:SetAlpha(1)
		
		Pulso.AgScale:Play()
	elseif event == "PLAYER_REGEN_ENABLED" then
		Player.Textura:SetVertexColor(1,1,1)
		Alvo.Textura:SetVertexColor(1,1,1)
		Player.Loop:SetDuration(3)
		Alvo.Loop:SetDuration(3)
		Player.SubTextura:SetAlpha(0)
		Alvo.SubTextura:SetAlpha(0)
		
		Pulso.AgScale:Stop()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end