local _, class = UnitClass("player")
if class == "MAGE" then

local id, borda
local function GetContinent()

	if C_Map.GetBestMapForUnit("player") then
		local thisMapType
		local mapID = C_Map.GetBestMapForUnit("player")
		while thisMapType ~= 0 do
			local mapDetails = C_Map.GetMapInfo(mapID)
			thisMapType = mapDetails.mapType
			if thisMapType == 2 then
				id = mapID
			end
			
			local thisMapName = mapDetails.name
			local thisMapParent = mapDetails.parentMapID
			mapID = thisMapParent
		end
		return id
	else
		return 946		
	end
	
	-- 0 = "Cosmic"
	-- 1 = "World"
	-- 2 = "Continent"
	-- 3 = "Zone"
	-- 4 = "Dungeon"
	-- 5 = "Micro"
	-- 6 = "Orphan"
	
	-- 13 - Reinos do Leste
	-- 12 - Kalimdor
	-- 113 - Nortúndria
	-- 101 - Terralém	
	-- 424 - Pandaria
	-- 572 - Draenor
	-- 619 - Legion (Broken Isles)
	-- 905 - Argus
	-- 946 - Void
	-- 947 - Azeroth - World - Cosmic	
	-- 948 - The Maeltrom - Voragem
end


local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("ZONE_CHANGED")
	Pulso:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	Pulso:RegisterEvent("ZONE_CHANGED_INDOORS")	
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Jogador = CreateFrame("Frame", nil, Pulso)
	Jogador.Textura = Jogador:CreateTexture(nil,"BACKGROUND")
	Jogador.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Jogador.Textura:SetSize(128,128)
	
	Jogador.Text = Jogador:CreateFontString(nil, "BORDER")
	Jogador.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Mage.ttf", 15)
	Jogador.Text:SetPoint("CENTER", Jogador.Textura)
	Jogador.Text:SetTextColor(1,1,1)
	Jogador.Text:SetShadowColor(0,0,0)
	Jogador.Text:SetShadowOffset(1,-1)

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(128,128)

	Alvo.Text = Alvo:CreateFontString(nil, "BORDER")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Mage.ttf", 15)
	Alvo.Text:SetPoint("CENTER", Alvo.Textura)
	Alvo.Text:SetTextColor(1,1,1)
	Alvo.Text:SetShadowColor(0,0,0)
	Alvo.Text:SetShadowOffset(1,-1)

--// Animations

	Pulso.AgFadeIn = Pulso:CreateAnimationGroup()
	local FadeIn = Pulso.AgFadeIn:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(1)
	FadeIn:SetOrder(1)
	
	Pulso.AgFadeOut = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFadeOut:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(1)
	FadeOut:SetOrder(1)


local function AplicarTextura(combate)
	local isInstance, instanceType = IsInInstance()
	local textura

	if combate then
		if GetSpecialization() == 1 then
			textura = "Mage_Arcane"
		elseif GetSpecialization() == 2 then
			textura = "Mage_Fire"
		elseif GetSpecialization() == 3 then
			textura = "Mage_Frost"
		end
	else
		if isInstance and instanceType == "pvp" then
			textura = "PVP"
		elseif isInstance and instanceType ~= "pvp" then
			textura = "Dungeon"
		else
			textura = borda
		end
	end
	
	Jogador.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Mage\\"..textura)
	Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Mage\\"..textura)	
end


--------------------|| OnFinished ||--------------------
local function OnFinished(self)
	
	if UnitAffectingCombat("player") then
		AplicarTextura(true)
	else
		AplicarTextura()
	end
	Pulso.AgFadeOut:Play()

end Pulso.AgFadeIn:SetScript("OnFinished", OnFinished)


local function OnEvent(self, event)

	borda = GetContinent()
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Jogador.Text:SetFormattedText("%.0f", hp)

	if	event == "ZONE_CHANGED_NEW_AREA" or event == "ZONE_CHANGED" or event == "LOADING_SCREEN_DISABLED" then
		AplicarTextura()
	end
	
	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		Alvo.Text:SetFormattedText("%.0f", hp)
		
		Alvo:Show()
	else		
		Alvo:Hide()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then		
		Pulso.AgFadeIn:Play()
	elseif event == "PLAYER_REGEN_ENABLED" then
		Pulso.AgFadeIn:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end