local _, class = UnitClass("player")
if class == "MONK" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_TARGET")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Player = CreateFrame("Frame", nil, Pulso)
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Monk\\Borda")
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(16, 128)
	Player.Textura:SetBlendMode("ADD")

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Monk\\Borda")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(16, 128)
	Alvo.Textura:SetBlendMode("ADD")

Player.Icon = {}
Alvo.Icon = {}
local size = 24
local horizontal, vertical = 0, 0
for i=1,5 do
	Player.Icon[i] = Player:CreateTexture(nil,"BORDER")
	Player.Icon[i]:SetTexture("Interface\\AddOns\\Pulso\\Images\\Monk\\Player ("..i..")")
	Player.Icon[i]:SetPoint("BOTTOMRIGHT", Player.Textura, "BOTTOMLEFT", horizontal, vertical)
	Player.Icon[i]:SetSize(size, size)
	-- Target
	Alvo.Icon[i] = Alvo:CreateTexture(nil,"BORDER")
	Alvo.Icon[i]:SetTexture("Interface\\AddOns\\Pulso\\Images\\Monk\\Alvo ("..i..")")
	Alvo.Icon[i]:SetPoint("BOTTOMLEFT", Alvo.Textura, "BOTTOMRIGHT", horizontal, vertical)
	Alvo.Icon[i]:SetSize(size, size)
	vertical = vertical + size
end

--// Animations

for i=1,5 do
	Player.Icon[i].AgFade = Player.Icon[i]:CreateAnimationGroup()
	local FadeOut = Player.Icon[i].AgFade:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.3)
	FadeOut:SetOrder(1)
	local FadeIn = Player.Icon[i].AgFade:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(.3)
	FadeIn:SetOrder(2)
	-- Target
	Alvo.Icon[i].AgFade = Alvo.Icon[i]:CreateAnimationGroup()
	local FadeO = Alvo.Icon[i].AgFade:CreateAnimation("Alpha")
	FadeO:SetFromAlpha(0)
	FadeO:SetToAlpha(1)
	FadeO:SetDuration(.3)
	FadeO:SetOrder(1)
	local FadeI = Alvo.Icon[i].AgFade:CreateAnimation("Alpha")
	FadeI:SetFromAlpha(1)
	FadeI:SetToAlpha(0)
	FadeI:SetDuration(.3)
	FadeI:SetOrder(2)
end


local function OnFinished(self)
	self:Play()
end

for i=1,5 do
	Player.Icon[i].AgFade:SetScript("OnFinished", OnFinished)
	Alvo.Icon[i].AgFade:SetScript("OnFinished", OnFinished)
end


local function AplicarVida(unit)
	
	local hp = UnitHealth(unit) * 100 / UnitHealthMax(unit)
	
	if unit == "player" then
		if hp >  5  then Player.Icon[1]:Show() else Player.Icon[1]:Hide() end
		if hp >= 20 then Player.Icon[2]:Show() else Player.Icon[2]:Hide() end
		if hp >= 40 then Player.Icon[3]:Show() else Player.Icon[3]:Hide() end
		if hp >= 60 then Player.Icon[4]:Show() else Player.Icon[4]:Hide() end
		if hp >= 80 then Player.Icon[5]:Show() else Player.Icon[5]:Hide() end
	else
		if hp >  5  then Alvo.Icon[1]:Show() else Alvo.Icon[1]:Hide() end
		if hp >= 20 then Alvo.Icon[2]:Show() else Alvo.Icon[2]:Hide() end
		if hp >= 40 then Alvo.Icon[3]:Show() else Alvo.Icon[3]:Hide() end
		if hp >= 60 then Alvo.Icon[4]:Show() else Alvo.Icon[4]:Hide() end
		if hp >= 80 then Alvo.Icon[5]:Show() else Alvo.Icon[5]:Hide() end
	end
	
	for i=1,4 do
		local p = i + 1
		if not Player.Icon[p]:IsShown() then
			Player.Icon[i].AgFade:Play()
		else
			Player.Icon[i].AgFade:Stop()
		end
		-- Target
		if not Alvo.Icon[p]:IsShown() then
			Alvo.Icon[i].AgFade:Play()
		else
			Alvo.Icon[i].AgFade:Stop()
		end
	end
end


local function OnEvent(self, event)

	AplicarVida("player")

	if UnitExists("target") then
		AplicarVida("target")
		Alvo:Show()		
	else
		Alvo:Hide()	
	end

	if event == "PLAYER_REGEN_DISABLED" then
		Player.Icon[5].AgFade:Play()
		Alvo.Icon[5].AgFade:Play()
		Player.Textura:SetVertexColor(1,0,0)
		Alvo.Textura:SetVertexColor(1,0,0)
	elseif event == "PLAYER_REGEN_ENABLED" then
		Player.Icon[5].AgFade:Stop()
		Alvo.Icon[5].AgFade:Stop()
		Player.Textura:SetVertexColor(1,1,1)
		Alvo.Textura:SetVertexColor(1,1,1)
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end