local Pet = CreateFrame("Frame", nil, PetFrame)
	Pet:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pet:RegisterEvent("UNIT_PET")
	Pet:RegisterEvent("UNIT_ENTERED_VEHICLE")
	Pet:RegisterEvent("UPDATE_VEHICLE_ACTIONBAR")
	Pet:RegisterEvent("VEHICLE_UPDATE")
	Pet:RegisterUnitEvent("UNIT_HEALTH", "pet")

	Pet.Textura = Pet:CreateTexture(nil,"BACKGROUND")
	Pet.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Pet\\Barra")
	Pet.Textura:SetPoint("BOTTOM", PetActionBarFrame, "TOP", horizontal, 0)
	Pet.Textura:SetSize(256,64)
	
	Pet.Textura:Hide()
	
	Pet.Icon = {}
local horizontal = -80
for i=1,4 do
	Pet.Icon[i] = Pet:CreateTexture(nil,"BORDER")
	Pet.Icon[i]:SetPoint("CENTER", Pet.Textura, "CENTER", horizontal, -15)
	Pet.Icon[i]:SetSize(64,64)
	horizontal = horizontal + 35
	
	Pet.Icon[i]:Hide()
end

--// Animations

	Pet.AgFade = Pet:CreateAnimationGroup()
	local Fade = Pet.AgFade:CreateAnimation("Alpha")
	Fade:SetFromAlpha(0)
	Fade:SetToAlpha(1)
	Fade:SetDuration(1)
	Fade:SetOrder(1)


local family = {
["Aberration"]="Aberração",
["Beast"]="Fera",
["Critter"]="Bicho",
["Demon"]="Demônio",
["Dragonkin"]="Dracônico",
["Elemental"]="Elemental",
["Gas Cloud"]="Gasoso",
["Giant"]="Gigante",
["Humanoid"]="Humanoide",
["Mechanical"]="Mecânico",
["Totem"]="Totem",
["Undead"]="Renegado",
["Not specified"]="Não especificado",
["Wild Pet"]="Não especificado",
}
local creature
local function OnEvent(self, event)

	local hasUI, isHunterPet = HasPetUI()
	if HasPetUI() then

		Pet:Show()
		Pet.Textura:Hide()

		if GetLocale() == "enUS" then
			creature = family[UnitCreatureType("pet")]
		else
			creature = UnitCreatureType("pet")
		end
		
		if not creature or creature == "" then
			creature = family["Not specified"]
		end

		for i=1,4 do
			Pet.Icon[i]:SetTexture("Interface\\AddOns\\Pulso\\Images\\Pet\\"..creature)
		end
		
		local hp = UnitHealth("pet") * 100 / UnitHealthMax("pet")

		if hp >= 20  then Pet.Icon[1]:Show() else Pet.Icon[1]:Hide() end
		if hp >= 40  then Pet.Icon[2]:Show() else Pet.Icon[2]:Hide() end
		if hp >= 60  then Pet.Icon[3]:Show() else Pet.Icon[3]:Hide() end
		if hp >= 80  then Pet.Icon[4]:Show() else Pet.Icon[4]:Hide() end
	else
		Pet:Hide()		
	end

end	Pet:SetScript("OnEvent", OnEvent)


-- /fstack