local _, class = UnitClass("player")
if class == "WARLOCK" then

local Pulso = CreateFrame("Frame", nil, UIParent)
	Pulso:RegisterEvent("LOADING_SCREEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_DISABLED")
	Pulso:RegisterEvent("PLAYER_REGEN_ENABLED")
	Pulso:RegisterEvent("PLAYER_TARGET_CHANGED")
	Pulso:RegisterEvent("UNIT_AURA")
	Pulso:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "player", "target")


local Player = CreateFrame("Frame", nil, Pulso)
	Player.Textura = Player:CreateTexture(nil,"BACKGROUND")
	Player.Textura:SetPoint("CENTER", UIParent, "CENTER", -250, -150)
	Player.Textura:SetSize(128, 128)
	Player.Textura:SetBlendMode("ADD")
	
	Player.SubTextura = Player:CreateTexture(nil,"BACKGROUND")
	Player.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\Fundo")
	Player.SubTextura:SetPoint("CENTER", Player.Textura)
	Player.SubTextura:SetSize(128, 128)
	
	Player.Text = Player:CreateFontString(nil, "BORDER")
	Player.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Warlock.ttf", 15)
	Player.Text:SetPoint("CENTER", Player.Textura)
	Player.Text:SetTextColor(1,.75,0)
	Player.Text:SetShadowColor(0,0,0)
	Player.Text:SetShadowOffset(1,-1)

local Alvo = CreateFrame("Frame", nil, Pulso)
	Alvo.Textura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.Textura:SetPoint("CENTER", UIParent, "CENTER", 250, -150)
	Alvo.Textura:SetSize(128, 128)
	Alvo.Textura:SetBlendMode("ADD")
	
	Alvo.SubTextura = Alvo:CreateTexture(nil,"BACKGROUND")
	Alvo.SubTextura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\Fundo")
	Alvo.SubTextura:SetPoint("CENTER", Alvo.Textura)
	Alvo.SubTextura:SetSize(128, 128)
	
	Alvo.Text = Alvo:CreateFontString(nil, "BORDER")
	Alvo.Text:SetFont("Interface\\AddOns\\Pulso\\Fonts\\Warlock.ttf", 15)
	Alvo.Text:SetPoint("CENTER", Alvo.Textura)
	Alvo.Text:SetTextColor(1,.75,0)
	Alvo.Text:SetShadowColor(0,0,0)
	Alvo.Text:SetShadowOffset(1,-1)

--// Animations

	Pulso.AgFadeIn = Pulso:CreateAnimationGroup()
	local FadeIn = Pulso.AgFadeIn:CreateAnimation("Alpha")
	FadeIn:SetFromAlpha(1)
	FadeIn:SetToAlpha(0)
	FadeIn:SetDuration(.7)
	FadeIn:SetOrder(1)

	Pulso.AgFadeOut = Pulso:CreateAnimationGroup()
	local FadeOut = Pulso.AgFadeOut:CreateAnimation("Alpha")
	FadeOut:SetFromAlpha(0)
	FadeOut:SetToAlpha(1)
	FadeOut:SetDuration(.7)
	FadeOut:SetOrder(1)


local function OnFinished(self)

	if Player.Textura:GetTexture() == "Interface\\AddOns\\Pulso\\Images\\Warlock\\1" then
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\2")
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\2")
		Player.Text:SetTextColor(.5,0,1)
		Alvo.Text:SetTextColor(.5,0,1)
	elseif Player.Textura:GetTexture() == "Interface\\AddOns\\Pulso\\Images\\Warlock\\2" then
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\3")
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\3")
		Player.Text:SetTextColor(1,1,0)
		Alvo.Text:SetTextColor(1,1,0)
	else
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\1")
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\1")
		Player.Text:SetTextColor(.5,1,0)
		Alvo.Text:SetTextColor(.5,1,0)
	end
	
	Pulso.AgFadeOut:Play()

end Pulso.AgFadeIn:SetScript("OnFinished", OnFinished)

local function FinishedOut(self)
	
	if UnitAffectingCombat("player") then
		Pulso.AgFadeIn:Play()
	end

end Pulso.AgFadeOut:SetScript("OnFinished", FinishedOut)




local function OnEvent(self, event)

	if event == "LOADING_SCREEN_DISABLED" then
		r = math.random(1,3)
		Player.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\"..r)
		Alvo.Textura:SetTexture("Interface\\AddOns\\Pulso\\Images\\Warlock\\"..r)
		if r == 1 then
			Player.Text:SetTextColor(.5,1,0)
			Alvo.Text:SetTextColor(.5,1,0)
		elseif r == 2 then
			Player.Text:SetTextColor(.5,0,1)
			Alvo.Text:SetTextColor(.5,0,1)
			
		elseif r == 3 then
			Player.Text:SetTextColor(1,1,0)
			Alvo.Text:SetTextColor(1,1,0)			
		end
	end
	
	local hp = UnitHealth("player") * 100 / UnitHealthMax("player")
	Player.Text:SetFormattedText("%.0f", hp)

	if UnitExists("target") then
		local hp = UnitHealth("target") * 100 / UnitHealthMax("target")
		Alvo.Text:SetFormattedText("%.0f", hp)
		
		Alvo:Show()
	else
		Alvo:Hide()
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		Pulso.AgFadeIn:Play()
	end

end	Pulso:SetScript("OnEvent", OnEvent)

end